* Contabil Profesional 4.49.282.811 29.04.10 11:47:55
*
* Aplicatie:GESTAT
* Titlu:    B. Iesiri -  5.1a - Cele mai bine vandute produse - in ordinea valorii de vanzare, defalcat intern / import
* Descriere:


dirBDCSursa	= __CaleCent
numeBDCSursa = "OCPRPA__"



If !File(__CaleCent+"PAPR.DBF") Then
	=Suna(MLD_EROARE)
	Do Erori.EXE With "SgNoPa",1,"",__CaleCENT
	Return
Endif

If OpnDbf(__CaleDBF, "Produse", "PR_NR_I", "Prod")
	If FSize("PR_KIMPDIR") = 0
		
		=Suna(MLD_EROARE)
		Do Info.EXE With "Nu pot", "Intrati mai intai in Produse", "Pentru a se adauga automat campul import direct"
	
		Return
	
	Endif

	=ClsDbf("Prod")
EndIf

*
* In prima clauza Select se face insumarea pe produse
*
Select 										;
	* 										;
	,Round(Sum(SQ_VAL),0) As SQ_VAL_T		;
	,Round(Sum(SQ_ADAOS),0) As SQ_ADAOS_T	;
	,Round(Sum(SQ_CANT),0) As SQ_CANT_T				;
From (dirBDCSursa+numeBDCSursa) 			;
Order By SQ_VAL_T Desc, SQ_PR_DENU 			;
Group By SQ_PR_DENU							;
Into Table Tmp1

* Determin ultimele preturi de achizitie din PAPR

Select 								;
		 SQ_PA_NR_I					;
		,SQ_PR_NR_I					;
		,Max(SQ_DATA) As MAX_DATA	;
From (__CaleCENT+"PAPR")			;
Group By SQ_PA_NR_I, SQ_PR_NR_I		;
Into Cursor cPaPrMax


Select p.*								;
	From (__CaleCENT+"PAPR") p			;
	,cPaPrMax c							;
Where 									;
		p.SQ_PA_NR_I = c.SQ_PA_NR_I		;
	And p.SQ_PR_NR_I = c.SQ_PR_NR_I		;
	And p.SQ_DATA	 = c.MAX_DATA		;
Into Table ..\SCRATCH\cPaPr

Index On Str(SQ_PA_NR_I)+Str(SQ_PR_NR_I) Tag xcPaPr


*
* Calculez stocurile momentane, din toate gestiunile
*
Select SM_NR_I_PR, Round(SUM(SM_STOC),0) As SM_STOC	;
From (__CaleDBF+"SM.DBF") 					;
Group By SM_NR_I_PR		 					;
Into Table ..\SCRATCH\SmTmp					;
Order By SM_NR_I_PR

Index On SM_NR_I_PR Tag SM_NR_I_PR



* Asigur sa existe in SMTMP toate articolele care sunt in tmp1
* (sa nu le pierd pe cele cu stoc 0)
* La fel si in cpaPr	- ala cu preturile de achizitie
Select tmp1
Scan All
	Scatter MemVar

	Select SmTmp
	Seek (m.SQ_PR_NR_I)
	If !Found() Then
		Append Blank
		Replace SM_NR_I_PR With m.SQ_PR_NR_I
	EndIf


	Select cPaPr
	Seek (Str(m.SQ_PA_NR_I)+Str(m.SQ_PR_NR_I))
	If !Found() Then
		Append Blank
		Replace SQ_PA_NR_I With m.SQ_PA_NR_I	;
			   ,SQ_PR_NR_I With m.SQ_PR_NR_I
	EndIf


	Select tmp1
EndScan



*
* In a doua clauza se creeaza si campul cu adaosul procentual
* (se selecteaza doar cele care au valoarea totala diferita de zero, pentru
* a nu avea erori
*
* aici e codul vechi, fara PA si SM_STOC
*
* Select 										;
* 	*										;
* 	,100*SQ_ADAOS_T/(SQ_VAL_T-SQ_ADAOS_T) As SQ_ADAOS_PR	;
*  From Tmp1 									;
* Where SQ_VAL_T != 0							;
* Order By SQ_VAL_T Desc, SQ_PR_DENU 			;
* Into Table tmp



*
* Selectez, mai nou
*
Select t.* , s.SM_STOC, p.SQ_DATA, p.SQ_P_FAC				;
	,100*SQ_ADAOS_T/(SQ_VAL_T-SQ_ADAOS_T) As SQ_ADAOS_PR	;
	From tmp1 t, smTmp s, cPaPr p				;
	Where SM_NR_I_PR = t.SQ_PR_NR_I				;
		And p.SQ_PR_NR_I =t.SQ_PR_NR_I			;
		And p.SQ_PA_NR_I =t.SQ_PA_NR_I			;
	Into Cursor cTmp


* 29/04/10 11:52:28 - dif fata de fis. original
* Acuma ordonez dupa coloana de import


Select t.*, pr.PR_KIMPDIR						;
From cTmp t										;
	,__CaleDBF+"Produse" pr						;
Where pr.PR_NR_I = t.SQ_PR_NR_I					;
Order By PR_KIMPDIR, SQ_VAL_T Desc, SQ_PR_DENU	;
Into Table tmp





*
* Inchid stocurile momentane si ma pozitionez pe Tmp
*
=ClsDbf("Produse")
=ClsDbf("cTmp")
=ClsDbf("SM")
=ClsDbf("SmTmp")
=ClsDbf("tmp1")
=ClsDbf("cPaPrMax")
=ClsDbf("cPaPr")
=ClsDbf("PaPr")

Select Tmp


*
* Daca vrea browse, il facem
*
If _sqVreaBrowse Then

	Browse 											;
		Normal										;
		NoMenu										;
		NoEdit										;
		NoAppend									;
		NoDelete									;
		Preference (_sqPrefBrowse) 					;
		Title (_sqTxtTitlu)							;
		Fields										;
			 SQ_PR_DENU		:H="Denumire produs"	;
			,SQ_VAL_T 		:H="Valoare totala"		;
							:P="9,999,999,999,999"	;
			,SQ_CANT_T		:H="Cantitate tot."		;
							:P="99,999,999"			;
			,SQ_ADAOS_T		:H="Val.Adaos Tot"		;
							:P="9,999,999,999,999"	

EndIf	&& _sqVreaBrowse
