* Contabil Profesional 4.47d 07.05.01 19:16:30
*
* Aplicatie:GESTAT
* Titlu:    B. Iesiri -  5.2 - Cele mai bine vandute produse - in ordinea valorii adaosului                                                                       
* Raport:   GE_ST_O05a
* Descriere:Produsele vandute pe o perioada, in ordinea adaosului de vanzare                                                                                                                                                                 

dirBDCSursa	= __CaleCent
numeBDCSursa = "OCPRPA__"

*
* In prima clauza Select se face insumarea pe produse
*

Select 										;
	* 										;
	,Sum(SQ_VAL) As SQ_VAL_T				;
	,Sum(SQ_ADAOS) As SQ_ADAOS_T			;
	,Sum(SQ_CANT) As SQ_CANT_T				;
From (dirBDCSursa+numeBDCSursa) 			;
Order By SQ_VAL_T Desc, SQ_PR_DENU 			;
Group By SQ_PR_DENU							;
Into Table Tmp1
*
* In a doua clauza se creeaza si campul cu adaosul procentual
* (se selecteaza doar cele care au valoarea totala diferita de zero, pentru
* a nu avea erori
*

Select 										;
	*										;
	,100*SQ_ADAOS_T/(SQ_VAL_T-SQ_ADAOS_T) As SQ_ADAOS_PR	;
 From Tmp1 									;		
Where SQ_VAL_T != 0							;
Order By SQ_ADAOS_T Desc, SQ_PR_DENU 			;
Into Table tmp

=ClsDBF("Tmp1")
If File("TMP1.DBF") Then
	Delete File TMP1.DBF
EndIf

*
* Daca vrea browse, il facem
*
If _sqVreaBrowse Then
		
	Browse 											;
		Normal										;
		NoMenu										;
		NoEdit										;
		NoAppend									;
		NoDelete									;
		Preference (_sqPrefBrowse) 					;
		Title (_sqTxtTitlu)							;
		Fields										;
			 SQ_PR_DENU		:H="Denumire produs"	;
			,SQ_VAL_T 		:H="Valoare totala"		;
							:P="9,999,999,999,999"	;
			,SQ_CANT_T		:H="Cantitate tot."		;
							:P="99,999,999"			;
			,SQ_ADAOS_T		:H="Val.Adaos Tot"		;
							:P="9,999,999,999,999"	

EndIf	&& _sqVreaBrowse
