* Contabil Profesional 4.49.345.1485 08.01.14 11:00:26
*
* Aplicatie:GESTAT
* Titlu:    B. Iesiri - 13.3 Produse in ordinea ritmului de vanzare
* Raport:   GE_ST_133
* Descriere:

* Bazat pe: B. Iesiri - 13.2 Produse in ordinea vitezei de miscare a stocului
dirBDCSursa	= __CaleCent
numeBDCSursa = "OCPRST__"

* le am pe luni, calculez medii pe perioada respectiva

Select											;
	 SQ_PR_NR_I									;
	,SQ_PR_DENU									;
	,SQ_PR_ABRE									;
	,SQ_PR_UM									;
	,Avg(SQ_ST_PU_A)			As SQ_ST_PU_A	;
	,Sum(SQ_ST_RL_I)			As SQ_ST_RL_I	;
	,Avg(SQ_ST_PU)				As SQ_ST_PU		;
	,Sum(SQ_ST_RL_E)			As SQ_ST_RL_E	;
	,Avg(SQ_ST_SF-SQ_ST_SF)		As SQ_ST_SF		;
	,000000.000000				As SQ_COEF		;
From (dirBDCSursa+numeBDCSursa) 				;
Group By SQ_PR_NR_I								;
Into Table ..\SCRATCH\tmp1




* Determin ultimele preturi de achizitie din PAPR

If !File(__CaleCent+"PAPR.DBF") Then
	=Suna(MLD_EROARE)
	Do Erori.EXE With "SgNoPa",1
	Return
Endif


Select 								;
		 SQ_PR_NR_I					;
		,Max(SQ_DATA) As MAX_DATA	;
From (__CaleCENT+"PAPR")			;
	Group By SQ_PR_NR_I				;
Into Cursor cPrMax


Select p.*								;
	From (__CaleCENT+"PAPR") p			;
	,cPrMax c							;
Where 									;
		p.SQ_PR_NR_I = c.SQ_PR_NR_I		;
	And p.SQ_DATA	 = c.MAX_DATA		;
Into Table ..\SCRATCH\cPr
Index On SQ_PR_NR_I Tag SQ_PR_NR_I


*
* Calculez stocurile momentane, din toate gestiunile
* (exclusiv cele de garantii)
*
Select										;
	 SM_NR_I_PR								;
	,SUM(SM_STOC) As SM_STOC				;
From (__CaleDBF+"SM.DBF") 					;
	Where GtFelGe(SM_NR_I_GE) = 1			;
Into Table ..\SCRATCH\SmTmp					;
	Group By SM_NR_I_PR		 				;
Order By SM_NR_I_PR
Index On SM_NR_I_PR Tag SM_NR_I_PR



* Asigur sa existe in SMTMP toate articolele care sunt in tmp1
* (sa nu le pierd pe cele cu stoc 0)
* La fel si in cPr	- ala cu preturile de achizitie
Select tmp1
Scan All
	Scatter MemVar

	Select SmTmp
	Seek (m.SQ_PR_NR_I)
	If !Found() Then
		Append Blank
		Replace SM_NR_I_PR With m.SQ_PR_NR_I
	EndIf


	Select cPr
	Seek (m.SQ_PR_NR_I)
	If !Found() Then
		Append Blank
		Replace SQ_PR_NR_I With m.SQ_PR_NR_I
	EndIf


	Select tmp1
EndScan




*
* Selectez
*

Select t.* , s.SM_STOC, p.SQ_DATA, p.SQ_P_FAC	;
	From tmp1 t, smTmp s, cPr p				;
	Where SM_NR_I_PR = t.SQ_PR_NR_I				;
		And p.SQ_PR_NR_I =t.SQ_PR_NR_I			;
	Into Table Tmp2



* Calculez coeficient ca find iesiri / media stocului final
* si ma sigur ca n-o sa impart la zero

Select tmp2
* Delete All For SQ_ST_SF = 0
Scan All

	If SM_STOC != 0
		Replace SQ_COEF With SQ_ST_RL_E / SM_STOC
	Else
		Replace SQ_COEF With SQ_ST_RL_E
	EndIf
EndScan



Select *							;
From tmp2							;
Into Table tmp						;
	Order By SQ_COEF, SQ_PR_DENU


*
* Inchid stocurile momentane si ma pozitionez pe Tmp
*
=ClsDbf("SM")
=ClsDbf("SmTmp")
=ClsDbf("tmp1")
=ClsDbf("tmp2")
=ClsDbf("cPrMax")
=ClsDbf("cPr")
=ClsDbf("PaPr")
Select Tmp



*
* Daca vrea browse, il facem
*
If _sqVreaBrowse Then

	Browse 											;
		Normal										;
		NoMenu										;
		NoEdit										;
		NoAppend									;
		NoDelete									;
		Preference (_sqPrefBrowse) 					;
		Title (_sqTxtTitlu)							;
		Fields										;
			 SQ_COEF		:H="Coef.viteza"		;
			,SQ_PR_DENU		:H="Denumire produs"	;
			,SQ_PR_ABRE		:H="Abreviere"			;
			,SQ_ST_PU_A		:H="PU Achiz"			;
							:P="99,999.99"			;
			,SQ_ST_RL_I		:H="Intrari"			;
							:P="9,999,999"			;
			,SQ_ST_RL_E		:H="Iesiri"				;
							:P="9,999,999"			;
			,SQ_ST_PU		:H="PU iesire"			;
							:P="99,999.99"			;
			,SQ_ST_SF		:H="Stoc"				;
							:P="99,999,999"			;
			,SQ_VAL=SQ_ST_SF * SQ_ST_PU				;
					   		:H="Valoare stoc"		;
							:P="999,999,999,999"	;
			,SQ_PR_UM		:H="UM"

EndIf	&& _sqVreaBrowse
