* Contabil Profesional 4.49.345.1497 22.01.2014 16:25:35
*
* Aplicatie:ANG
* Titlu:    Lista angajatilor existenti intr-o luna calendaristica
* Raport:   ANG
* Descriere: Angajatii care sunt angajati intr-o anumita luna

*
* Bazat pe: Lista angajatilor la o anumita data ordonata dupa nume si prenume
*
* Obtin statutul angajatilor pentru data ceruta
*

Public pZi, uZi

pZi = PrimaZi(Data_Sel)
uZi = UltimaZi(Data_Sel)


Select   a.AN_NR_I					;
		,Max(s.ANS_DATA)As ANS_DATA	;
									;
	From Angajati a, Ang_Star s		;
									;
Where s.ANS_NR_I_A = a.AN_NR_I		;
	and s.ANS_DATA <= uZi			;
Group By AN_NR_I					;
Into Cursor cData


*
* Acuma chiar selectez pe cei care-s angajati la acesta data, cu
* statele valabile in respectivulmoment
*

Select a.AN_NR_I, a.AN_ABREV, a.AN_NUME, a.AN_PRENUME, a.AN_CNP		;
	  ,a.AN_DATA_AN, a.AN_C_NR, a.AN_C_DATA							;
	  ,a.AN_DATA_CO													;
	  ,a.AN_CONT_BA													;
	  ,SubStr(AllTrim(Str(a.AN_CNP)),2,6) As sqlDATA_N				;
	  ,s.ANS_DATA, s.ANS_FUNCTIA, s.ANS_TIP_AN, s.ANS_SINC  		;
	From Angajati a, Ang_Star s, cData c							;
	Where 															;
		s.ANS_NR_I_A = a.AN_NR_I									;
		And s.ANS_NR_I_A = c.AN_NR_I								;
		And IntersD(a.AN_DATA_AN, a.AN_DATA_CO, pZi, uZi) 			;
		And s.ANS_DATA	= c.ANS_DATA								;
		And a.AN_NR_I = c.AN_NR_I									;
																	;
	Order By a.AN_NUME, a.AN_PRENUME								;
	Into Table tmp

=ClsDbf("cData")


Select tmp
